

/****************************************************************************

Title:    Access serial DS1621 Temp-Sensor using I2C interace

Quelle i2cmaster.h und twimaster.c: Peter Fleury <pfleury@gmx.ch>

http://jump.to/fleury

Software: AVR-GCC

Hardware: ATMEGA32 at 4 Mhz

Liest die Temperatur stndig aus und sendet diese ohne Nachkommastelle ber Seriell 8N1

DS1621 Adresse 7 (alle drei Adresspins auf VCC)

10k-Ohm Buswiderstnde

*****************************************************************************/

 

#include <avr/io.h>

#include <util/delay.h>

#include "i2cmaster.h"

#include "twimaster.c"

 

#ifndef F_CPU

#warning "F_CPU war noch nicht definiert, wird nun nachgeholt mit 4000000"

#define F_CPU 4000000L

#endif 

#define BAUD 9600L    

#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   // clever runden

#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     // Reale Baudrate

#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD-1000) // Fehler in Promille

#define Dev24C02  0xA2      // device address of EEPROM 24C02, see datasheet

 

#define DS1621_Write  0x9E

#define DS1621_Read   0x9F

 

void warte()

{

                 int i;

                 for (i=0;i<10;i++)

                   _delay_ms(20);

}

 

 

int main(void)

{

    unsigned char ret, TempH, TempL, data, test;

    int i;

 

    DDRB  = 0xff;                              // use all pins on port B for output

    PORTB = 0xff;                              // (active low LED's )

    UBRRH = UBRR_VAL >> 8;      /* Baudrate einstellen */

    UBRRL = UBRR_VAL & 0xFF;  /* Baudrate einstellen */

                 UCSRB |= (1<<TXEN);                       /* UART TX einschalten */

                 test = 'x';

 

    i2c_init();                                // init I2C interface

                

                 test = i2c_start(DS1621_Write);

                 // test kann bei Bedarf  ausgewertet werden

                 test = i2c_write(0xEE);

                 // test kann bei Bedarf  ausgewertet werden

                 i2c_stop();

                

                 i2c_start(DS1621_Write);

                 i2c_write(0xAA);

                 i2c_stop();

                 warte();

                 while (1)

                 {

                 i2c_start(DS1621_Read);

                 data = i2c_readAck();

                 TempH = data;

                 data = i2c_readNak();

                 TempL = data;

                 i2c_stop();

 

                 while (!(UCSRA & (1<<UDRE))) 

                                  {                                                                  /* warten bis Senden moeglich */

                                  }

 

                 UDR = TempH;

                

                 for (i=0;i<10;i++)

                 _delay_ms(100);

                 warte();

                 }

}

